(use sdl)
(use sdl.image)

;;
;; wait-key
;; wait until a key is pressed and released
;;
(define (wait-key)
  (define (wait-key-helper e)
    (let ((count (sdl-poll-event e)))
      (cond ((and (> count 0)
                  (= SDL_KEYUP (sdl-event-type e)))
             #t)
            (else
             (sdl-delay 10)
             (wait-key-helper e)))))

  (let ((e (sdl-make-event)))
    (wait-key-helper e)))

;;
;; run-test
;;
(define (run-test)
  (sdl-init SDL_INIT_VIDEO)

  (let ((screen (sdl-set-video-mode 640 480 16 0)))
    (let ((bmp (img-load "../sample.bmp")))
      (if (not (sdl-surface? bmp))
          (display (img-get-error))
          (sdl-blit-surface bmp #f screen #f)))

    (sdl-flip screen))

  (wait-key)

  (sdl-quit))


(run-test)
