(use sdl)
(use sdl.mixer)

;;
;; wait-for-sound
;; loop until sound has stopped
;;
(define (wait-for-sound)
  (cond ((zero? (mix-playing -1)) #t)
        (else
         (sdl-delay 10)
         (wait-for-sound))))

;;
;; run-test
;;
(define (run-test)
  (sdl-init SDL_INIT_AUDIO)

  (mix-open-audio MIX_DEFAULT_FREQUENCY MIX_DEFAULT_FORMAT
                  MIX_DEFAULT_CHANNELS 1024)

  (let ((chunk (mix-load-wav "generic.wav")))
    (if (mix-chunk? chunk)
        (mix-play-channel -1 chunk 5)
        (format #t "Could not load \"generic.wav\"\n"))

    (wait-for-sound))

  (mix-close-audio)
  (sdl-quit))


(run-test)