/*
 * gauche-sdl-ttf.h - Gauche SDL_ttf extension
 *
 *  Copyright(C) 2003 by Michael Vess (mvess@michaelvess.com)
 *
 *  Permission to use, copy, modify, distribute this software and
 *  accompanying documentation for any purpose is hereby granted,
 *  provided that existing copyright notices are retained in all
 *  copies and that this notice is included verbatim in all
 *  distributions.
 *  This software is provided as is, without express or implied
 *  warranty.  In no circumstances the author(s) shall be liable
 *  for any damages arising out of the use of this software.
 *
 *  $Id: gauche-sdl-ttf.h,v 1.2 2003/02/25 02:23:14 mikiso Exp $
 */

#ifndef GAUCHE_SDL_TTF_H
#define GAUCHE_SDL_TTF_H

#include "../gauche-sdl.h"

#include <SDL/SDL_ttf.h>

/*****************************************************************************
 * TTF
 */

/* Font */
typedef struct ScmTtfFontRec {
    SCM_HEADER;
    TTF_Font *font;
} ScmTtfFont;

SCM_CLASS_DECL(Scm_TtfFontClass);
#define SCM_CLASS_TTF_FONT          (&Scm_TtfFontClass)
#define SCM_TTF_FONT(obj)           (((ScmTtfFont*)(obj))->font)
#define SCM_TTF_FONT_P(obj)         SCM_XTYPEP(obj, SCM_CLASS_TTF_FONT)
#define SCM_TTF_FONT_OR_NULL(obj)   (SCM_FALSEP(obj)?NULL:SCM_TTF_FONT(obj))
#define SCM_TTF_FONT_OR_NULL_P(obj) (SCM_FALSEP(obj)||SCM_TTF_FONT_P(obj))

void ttf_font_finalize(ScmObj obj, void *data);

#endif /* GAUCHE_TTF_TTF_H */
